
-- skydiving
-- like that one scrapped pt music or was it level
-- i dont know
-- -Pacola

-- pac this is groundpound.lua
-- -Alternative

-- i forgor to change this
-- -Pacola

freeslot(
	"S_ASNICK_GPSTART",
	"S_ASNICK_GPOUNDING",
	"S_ASNICK_GPLAND",
	"sfx_sgpstr",
	"sfx_sgplop",
	"SPR_SNSS",
	"S_ASNICK_GPFX",
	"SPR_SNGP",
	"S_ASNICK_GPLANDFX"
)

states[S_ASNICK_GPSTART] = {
	sprite = SPR_PLAY,
	frame = SPR2_FLY_|FF_ANIMATE,
	tics = (F+1)*2,
	nextstate = S_ASNICK_GPOUNDING,
	var1 = F,
	var2 = 2,
}

states[S_ASNICK_GPOUNDING] = {
	sprite = SPR_PLAY,
	frame = SPR2_TIRE|FF_ANIMATE,
	tics = -1,
	nextstate = S_ASNICK_GPOUNDING,
	var1 = C,
	var2 = 2,
}

states[S_ASNICK_GPLAND] = {
	sprite = SPR_PLAY,
	frame = SPR2_LAND|FF_ANIMATE,
	tics = (I+1)*2,
	nextstate = S_PLAY_STND,
	var1 = I,
	var2 = 2,
}

sfxinfo[sfx_sgpstr].caption = "Ground Pound"
sfxinfo[sfx_sgplop].caption = "Pounding the Ground"

states[S_ASNICK_GPFX] = {
	sprite = SPR_SNSS,
	frame = A|FF_ANIMATE,
	tics = -1,
	nextstate = S_ASNICK_GPFX,
	var1 = D,
	var2 = 2,
}

states[S_ASNICK_GPLANDFX] = {
	sprite = SPR_SNGP,
	frame = A|FF_ANIMATE,
	tics = (G+1)*2,
	nextstate = S_NULL,
	var1 = G,
	var2 = 2,
}

local function canGP(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or (p.mo.eflags & MFE_SPRUNG)
	or ((p.pflags & PF_STASIS) and not p.asnickgp.landed)
	or p.powers[pw_carry]
	or p.asnickfireass
	or p.asnickwallrun
	or p.asnickceilbonk
	or p.altsnicksj.enabled
	or p.altsnickrobot
		return false
	end
	return true
end

local function shouldMomz(pmo, momz)
	local umomz = momz or 1
	if umomz < 0
	and (pmo.eflags & MFE_VERTICALFLIP)
		umomz = -$
	end
		
	if ((pmo.momz <= umomz and not (pmo.eflags & MFE_VERTICALFLIP)) or (pmo.momz >= umomz and (pmo.eflags & MFE_VERTICALFLIP)))
		return true
	end
	return false
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.asnickgp == nil
		p.asnickgp = {
			active = false,
			landed = false,
			momz = 0,
			o = nil
		}
	end
	
	if (p.cmd.buttons & BT_JUMP)
		p.altsnickjump = $+1
	else
		p.altsnickjump = 0
	end
	
	local gp = p.asnickgp
	local m = p.asnickmach
	if ((p.altsnickspin == 1 and m.num < 2) or (p.altsnickdived and p.altsnickjump == 1))
	and not P_IsObjectOnGround(p.mo)
	and not gp.active
	and canGP(p)
		S_StartSound(p.mo, sfx_sgpstr)
		local mul = FU
		if (p.mo.eflags & MFE_UNDERWATER)
			mul = FixedDiv(2, 3)
		end
		P_SetObjectMomZ(p.mo, FixedMul(8*p.mo.scale, mul))
		p.mo.state = S_ASNICK_GPSTART
		gp.landed = false
		gp.active = true
	end
	
	if gp.active
		p.powers[pw_strong] = $1|STR_SPRING|STR_HEAVY|STR_ATTACK|STR_ANIM
		
		if not canGP(p)
			if gp.overlay
			and (p.mo.eflags & MFE_SPRUNG)
				local mul = min(max(FU+FU/4, p.mo.momz/32), FU+FU/2)
				p.mo.momx = FixedMul($, mul)
				p.mo.momy = FixedMul($, mul)
				p.mo.momz = FixedMul($, mul)
			end
			gp.active = false
			return
		end
		
		if shouldMomz(p.mo, -FU)
			P_SetObjectMomZ(p.mo, -(FU-FU/3), true)
			--if shouldMomz(p.mo, -32*FU)
			if shouldMomz(p.mo, -24*FU)
				p.powers[pw_strong] = $1|STR_FLOOR|STR_ANIM
				if not gp.overlay
					gp.overlay = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
					local o = gp.overlay
					o.target = p.mo
					o.state = S_ASNICK_GPFX
				end
			end
		end
		
		if P_IsObjectOnGround(p.mo)
		and not gp.landed
			if p.mo.standingslope
				local s = p.mo.standingslope
				local sang = s.xydirection
				local x = cos(sang)
				local y = sin(sang)
				if p.mo.z < P_GetZAt(s, p.mo.x+32*x, p.mo.y+32*y)
					sang = $+ANGLE_180
				end
				
				gp.active = false
				local num = min(max(5*FU, abs(gp.momz)), 32*FU)
				m.time = FixedMul(FixedMul(num, FixedDiv(2734375, 1000000)), FU+FU/2)/FU
				--m.time = FixedMul(FixedMul(num, FixedDiv(2734375, 1000000)), FU+FU/2)/FU
				--print(m.time, abs(gp.momz)/FU)
				P_InstaThrust(p.mo, sang, p.normalspeed)
				P_MovePlayer(p)
				p.mo.state = S_PLAY_RUN
				return
			elseif (p.cmd.buttons & BT_SPIN)
				gp.active = false
				local num = max(5*FU, abs(gp.momz))
				if m.time < 8*TICRATE
					m.time = $+FixedMul(num, FixedDiv(2734375, 1000000))/FU
				end
				--print(FixedMul(num, FixedDiv(2734375, 1000000))/FU, abs(gp.momz)/FU)
				P_InstaThrust(p.mo, p.mo.angle, p.normalspeed)
				P_MovePlayer(p)
				p.mo.state = S_PLAY_RUN
				return
			else
				S_StartSound(p.mo, sfx_sgphit)
				p.mo.state = S_ASNICK_GPLAND
				gp.landed = true
				local o = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
				o.target = p.mo
				o.state = S_ASNICK_GPLANDFX
				o.dispoffset = p.mo.dispoffset-1
				if (gp.overlay and gp.overlay.valid)
					P_RemoveMobj(gp.overlay)
				end
				if p.powers[pw_shield] == SH_ARMAGEDDON
					P_BlackOw(p)
				end
			end
		elseif not P_IsObjectOnGround(p.mo)
			gp.momz = p.mo.momz
		end
		
		if gp.landed
			if S_SoundPlaying(p.mo, sfx_sgplop)
				S_StopSoundByID(p.mo, sfx_sgplop)
			end
			if p.speed > FU/4
				P_Thrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), -FU)
			else
				P_InstaThrust(p.mo, 0, 0)
			end
			p.pflags = $1|PF_FULLSTASIS
			if p.mo.state ~= S_ASNICK_GPLAND
				gp.landed = false
				gp.active = false
			end
		elseif not S_SoundPlaying(p.mo, sfx_sgplop)
		and not S_SoundPlaying(p.mo, sfx_sgpstr)
		and shouldMomz(p.mo, 0)
			S_StartSound(p.mo, sfx_sgplop)
		end
	elseif S_SoundPlaying(p.mo, sfx_sgplop)
		S_StopSoundByID(p.mo, sfx_sgplop)
	elseif gp.overlay
		if (gp.overlay and gp.overlay.valid)
			P_RemoveMobj(gp.overlay)
		end
		gp.overlay = nil
	end
end)