

-- adds the effects for mach running
-- like the farts peppino does when running

freeslot(
	"SPR_SNDC",
	"S_ASNICK_M2FX",
	"SPR_SNM3",
	"S_ASNICK_M3FX",
	"SPR_SNWT",
	"S_ASNICK_WATERFX",
	"SPR_SNFL",
	"S_ASNICK_M4FIRE",
	"SPR_SNOF",
	"S_ASNICK_M4OTHERFX"
)

states[S_ASNICK_M2FX] = {
	sprite = SPR_SNDC,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	tics = (E+1)*3,
	nextstate = S_NULL,
	var1 = E,
	var2 = 3
}

states[S_ASNICK_M3FX] = {
	sprite = SPR_SNM3,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE,
	tics = (H+1)*3,
	nextstate = S_NULL,
	var1 = H,
	var2 = 3
}

states[S_ASNICK_WATERFX] = {
	sprite = SPR_SNWT,
	frame = A|FF_ANIMATE,
	tics = (K+1)*3,
	nextstate = S_NULL,
	var1 = K,
	var2 = 3
}

states[S_ASNICK_M4FIRE] = {
	sprite = SPR_SNFL,
	frame = A|FF_ANIMATE,
	tics = (H+1)*3,
	nextstate = S_NULL,
	var1 = H,
	var2 = 3
}

states[S_ASNICK_M4OTHERFX] = {
	sprite = SPR_SNOF,
	frame = A|FF_ANIMATE,
	tics = (G+1)*4,
	nextstate = S_NULL,
	var1 = G,
	var2 = 4
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick"
	or p.altsnickrobot return end
	
	local m = p.asnickmach
	if m.num >= 3
	and p.panim == PA_RUN
		if leveltime%10 == 0
		and P_IsObjectOnGround(p.mo)
			if p.mo.z == p.mo.watertop
				local o = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				o.state = S_ASNICK_WATERFX
				o.angle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
				o.scale = p.mo.scale
			else
				for i = 1, 2 do
					local mul = 1
					if i == 2 mul = -1 end
					
					local ang = p.drawangle-ANGLE_90
					local x = cos(ang)
					local y = sin(ang)
					
					local o = P_SpawnMobj(p.mo.x+32*x*mul, p.mo.y+32*y*mul, p.mo.z, MT_THOK)
					o.state = S_ASNICK_M3FX
					o.angle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)+(ANG15*mul)
					o.scale = p.mo.scale
				end
			end
		elseif leveltime%5 == 0
		and m.num == 4
			for i = 1, 2 do
				local mul = 1
				if i == 2 mul = -1 end
				
				local ang = p.drawangle-ANGLE_90
				local x = cos(ang)
				local y = sin(ang)
				
				local f = P_SpawnMobj(p.mo.x+32*x*mul, p.mo.y+32*y*mul, p.mo.z, MT_THOK)
				f.state = S_ASNICK_M4FIRE
				f.angle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
				f.scale = p.mo.scale
			end
		end
		
		/*if m.num == 4
		and leveltime%20 == 0
			local ofx = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
			ofx.state = S_ASNICK_M4OTHERFX
			ofx.target = p.mo
			ofx.angle = p.drawangle
			ofx.scale = p.mo.scale
		end*/
	elseif m.num <= 2 
	and (p.panim == PA_RUN or p.panim == PA_WALK)
	and leveltime%15 == 0
	and P_IsObjectOnGround(p.mo)
		for i = 1, 2 do
			local mul = 1
			if i == 2 mul = -1 end
			
			local ang = p.drawangle-ANGLE_90
			local x = cos(ang)
			local y = sin(ang)
			
			local o = P_SpawnMobj(p.mo.x+16*x*mul, p.mo.y+16*y*mul, p.mo.z, MT_THOK)
			o.state = S_ASNICK_M2FX
			o.angle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)+(ANG15*mul)
			o.scale = p.mo.scale
		end
	end
end)