
-- fire snick
-- you go to fire
-- and snick becomes fire
-- -Pacola :D

freeslot(
	"S_ASNICK_FUP",
	"S_ASNICK_FSLIDE",
	"S_ASNICK_RECOVER"
)

states[S_ASNICK_FUP] = {
	sprite = SPR_PLAY,
	frame = SPR2_SPIN,
	tics = -1,
	action = A_RoboAnim,
	nextstate = S_ASNICK_FUP,
	var1 = A,
	var2 = 2
}

RoboVars[S_ASNICK_FUP] = {
	var3 = A,
	lframe = C
}

states[S_ASNICK_FSLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SPIN,
	tics = 12*2,
	action = A_RoboAnim,
	nextstate = S_ASNICK_RECOVER,
	var1 = D,
	var2 = 2
}

RoboVars[S_ASNICK_FSLIDE] = {
	var3 = D,
	lframe = O
}

states[S_ASNICK_RECOVER] = {
	sprite = SPR_PLAY,
	frame = SPR2_CNT1|FF_ANIMATE,
	tics = (O+1)*3,
	nextstate = S_PLAY_STND,
	var1 = O,
	var2 = 3
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.asnickfireass
		if p.asnickparry
			p.asnickparry = false
		end
		p.powers[pw_strong] = $1|STR_ATTACK|STR_ANIM
		if P_IsObjectOnGround(p.mo)
			p.pflags = $1|PF_FULLSTASIS
			if p.mo.state ~= S_ASNICK_FSLIDE
			and p.mo.state ~= S_ASNICK_RECOVER
				P_InstaThrust(p.mo, p.drawangle, 15*FU)
				p.mo.state = S_ASNICK_FSLIDE
			end
		elseif not P_IsObjectOnGround(p.mo)
		and p.mo.state ~= S_ASNICK_FUP
			p.mo.state = S_ASNICK_FUP
		end
		
		if p.mo.state == S_ASNICK_RECOVER
			p.asnickfireass = false
		end
	end
	
	if p.mo.state == S_ASNICK_RECOVER
		p.pflags = $1|PF_FULLSTASIS
	end
end)

addHook("MobjDamage", function(pmo, _, _, _, dmg)
	local p = pmo.player
	
	if pmo.skin ~= "altsnick"
	or dmg ~= DMG_FIRE
	or (dmg & DMG_DEATHMASK) return end
	
	p.asnickmach.time = 0
	p.altsnickrobot = false
	--P_SetOrigin(pmo, pmo.x, pmo.y, pmo.z+FU)
	P_SetObjectMomZ(pmo, 15*FU)
	pmo.state = S_ASNICK_FUP
	p.asnickfireass = true
	return true
end, MT_PLAYER)