
-- handles the colors for the super jump
-- which are also avaiable to change via a command
-- -Pacola (who is the only one that even makes all of these different lua files for different stuff)

-- im trying to figure out why even type your name in every single lua file and like even twice or something
-- you're the only coder
-- -Alt

-- well, you added comments now alt
-- and i think i added this here before average stopped doing code
-- thus the "different lua files for different stuff"
-- -Pacola

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.asnicksjcolor == nil
		p.asnicksjcolor = "invcolor"
	end
	
	local sj = p.altsnicksj
	
	if (sj and sj.enabled)
	and not p.asnicksjoverlay
		p.asnicksjoverlay = P_SpawnMobj(0, 0, 0, MT_OVERLAY)
		local o = p.asnicksjoverlay
		o.target = p.mo
		o.state = p.mo.state
		o.skin = p.mo.skin
		o.assjoverlay = true
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid)
	or mo.target.skin ~= "altsnick"
	or not mo.assjoverlay return end
	
	local pmo = mo.target
	local p = pmo.player
	local sj = p.altsnicksj
	
	local color = p.asnicksjcolor
	if p.asnicksjcolor == "invcolor"
		color = ColorOpposite(pmo.color)
		if pmo.color == SKINCOLOR_PURPLE
			color = SKINCOLOR_SUPERSNICK
		end
	end
	
	mo.state = pmo.state
	mo.frame = pmo.frame
	mo.tics = pmo.tics
	mo.anim_duration = pmo.anim_duration
	mo.color = color
	mo.dispoffset = pmo.dispoffset+1
	if not sj.enabled
		p.asnicksjoverlay = nil
		P_RemoveMobj(mo)
		return
	end
end, MT_OVERLAY)

COM_AddCommand("snick_superjumpcolor", function(p, arg)
	if arg == nil 
		local str = "snick_superjumpcolor <color> - Changes your super jump color, use -1 to use your opposite color!"
		if (p and p.valid)
			CONS_Printf(p, str)
		else
			print(str)
		end
		return
	end
	if not (p and p.valid) print("you're not valid") return end
	if p.mo.skin ~= "altsnick" CONS_Printf(p, "please use snick") return end
	
	local color = "haha"
	local narg = tonumber(arg)
	if narg
	and (narg >= 1 and narg <= #skincolors)
	and (skincolors[narg] and skincolors[narg].name)
		color = narg
	elseif narg
	and narg == -1
		color = "invcolor"
	end
	
	if R_GetColorByName(arg)
		color = R_GetColorByName(arg)
	end
	
	if (tonumber(color) and tonumber(color) >= 1 and tonumber(color) <= #skincolors and not (skincolors[color] and skincolors[color].name))
	or not R_GetColorByName(arg) and color ~= "invcolor" CONS_Printf(p, "That's an invalid color.") return end
	
	p.asnicksjcolor = color
end)