
-- fixes animations that are too slow
-- like the standing one
-- by pacola

-- hi, if you see this, fix snicks edge anim speed please
-- -alt

-- ok alt i will fix snick edging animation
-- -pacola

addHook("PlayerSpawn", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "altsnick" return end
	
	if p.mo.state == S_PLAY_STND
		p.mo.state = S_PLAY_STND
	end
end)

freeslot("S_ASNICK_JUMPFALL")

states[S_ASNICK_JUMPFALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_CNT2,
	tics = 2,
	nextstate = S_ASNICK_JUMPFALL
}

addHook("ThinkFrame", function(p)
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "altsnick" continue end
		
		if p.mo.state == S_PLAY_SKID
		and p.mo.frame == A
			p.mo.frame = $1|FF_ANIMATE
		end
		
		if (p.mo.state == S_PLAY_STND or p.mo.state == S_PLAY_SKID or p.mo.state == S_PLAY_EDGE)
		and p.mo.anim_duration > 2
			p.mo.anim_duration = 2
		elseif p.mo.state == S_PLAY_WAIT
		and p.mo.anim_duration > 3
			p.mo.anim_duration = 3
		end
		
		if p.mo.state == S_PLAY_WAIT
		and p.mo.frame == Z|FF_ANIMATE
			p.mo.state = S_PLAY_STND
		end
		
		if p.mo.state == S_PLAY_EDGE
			p.mo.state = S_PLAY_STND
		end
		
		if p.mo.state == S_PLAY_DRWN -- making sure you DO NOT use the DRWN sprites.
			p.mo.state = S_PLAY_DEAD
		end
		
		if p.mo.state == S_PLAY_FALL
		and (p.pflags & PF_JUMPED)
			p.mo.state = S_ASNICK_JUMPFALL
		end
		
		if p.asnickmach.num == 2
			p.charflags = $ & ~SF_NOJUMPSPIN
		else
			p.charflags = $1|SF_NOJUMPSPIN
		end
	end
end)