
-- handles the animations for robo snick
-- so it can use only SPR2_CLNG :D
-- -Pacola

-- future pacola here
-- parry also uses this so uhhh hi

function A_RoboAnim(pmo, v1, v2)
	if not (pmo.player and pmo.player.valid) return end
	
	local p = pmo.player
	local rv = RoboVars[pmo.state]
	
	pmo.frame = (v1 or A)
	p.asnickanims = {
		animdur = (v2 or 1),
		loopframe = (rv.var3 or A),
		lframe = (rv.lframe or skins[p.mo.skin].sprites[pmo.sprite2].numframes-1)
	}
	p.asnickanimtimer = (v2 or 1)
	--print("hi")
end

if not RoboVars
	rawset(_G, "RoboVars", {})
end

addHook("ThinkFrame", function(p)
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or p.mo.skin ~= "altsnick" continue end -- you shouldnt even have an A_RoboAnim state with a character that isn't snick.
		
		if states[p.mo.state].action ~= A_RoboAnim p.asnickanims = {} continue end
		
		local anim = p.asnickanims
		
		if p.asnickanimtimer
			p.asnickanimtimer = $-1
		else
			if p.mo.frame+1 > anim.lframe
				p.mo.frame = anim.loopframe
			else
				p.mo.frame = $+1
			end
			p.asnickanimtimer = anim.animdur
		end
	end
end)